﻿// CodeGear C++Builder
// Copyright (c) 1995, 2024 by Embarcadero Technologies, Inc.
// All rights reserved

// (DO NOT EDIT: machine generated header) 'IKLayer.pas' rev: 36.00 (Windows)

#ifndef IklayerHPP
#define IklayerHPP

#pragma delphiheader begin
#pragma option push
#if defined(__BORLANDC__) && !defined(__clang__)
#pragma option -w-      // All warnings off
#pragma option -Vx      // Zero-length empty class member 
#endif
#pragma pack(push,8)
#include <System.hpp>
#include <SysInit.hpp>
#include <Winapi.Windows.hpp>
#include <Winapi.Messages.hpp>
#include <System.Classes.hpp>
#include <System.Math.hpp>
#include <System.SysUtils.hpp>
#include <Vcl.Graphics.hpp>
#include <System.TypInfo.hpp>
#include <IKTypes.hpp>
#include <Winapi.GDIPAPI.hpp>
#include <Winapi.GDIPOBJ.hpp>
#include <IKRender.hpp>
#include <IKImage.hpp>
#include <IKAnimation.hpp>

//-- user supplied -----------------------------------------------------------

namespace Iklayer
{
//-- forward type declarations -----------------------------------------------
class DELPHICLASS IKLayerException;
class DELPHICLASS TIKLayers;
class DELPHICLASS TIKLayer;
class DELPHICLASS TIKOvalLayer;
//-- type declarations -------------------------------------------------------
#pragma pack(push,4)
class PASCALIMPLEMENTATION IKLayerException : public System::Sysutils::Exception
{
	typedef System::Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ inline __fastcall IKLayerException(const System::UnicodeString Msg) : System::Sysutils::Exception(Msg) { }
	/* Exception.CreateFmt */ inline __fastcall IKLayerException(const System::UnicodeString Msg, const System::TVarRec *Args, const System::NativeInt Args_High) : System::Sysutils::Exception(Msg, Args, Args_High) { }
	/* Exception.CreateRes */ inline __fastcall IKLayerException(System::NativeUInt Ident)/* overload */ : System::Sysutils::Exception(Ident) { }
	/* Exception.CreateRes */ inline __fastcall IKLayerException(System::PResStringRec ResStringRec)/* overload */ : System::Sysutils::Exception(ResStringRec) { }
	/* Exception.CreateResFmt */ inline __fastcall IKLayerException(System::NativeUInt Ident, const System::TVarRec *Args, const System::NativeInt Args_High)/* overload */ : System::Sysutils::Exception(Ident, Args, Args_High) { }
	/* Exception.CreateResFmt */ inline __fastcall IKLayerException(System::PResStringRec ResStringRec, const System::TVarRec *Args, const System::NativeInt Args_High)/* overload */ : System::Sysutils::Exception(ResStringRec, Args, Args_High) { }
	/* Exception.CreateHelp */ inline __fastcall IKLayerException(const System::UnicodeString Msg, int AHelpContext) : System::Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ inline __fastcall IKLayerException(const System::UnicodeString Msg, const System::TVarRec *Args, const System::NativeInt Args_High, int AHelpContext) : System::Sysutils::Exception(Msg, Args, Args_High, AHelpContext) { }
	/* Exception.CreateResHelp */ inline __fastcall IKLayerException(System::NativeUInt Ident, int AHelpContext)/* overload */ : System::Sysutils::Exception(Ident, AHelpContext) { }
	/* Exception.CreateResHelp */ inline __fastcall IKLayerException(System::PResStringRec ResStringRec, int AHelpContext)/* overload */ : System::Sysutils::Exception(ResStringRec, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ inline __fastcall IKLayerException(System::PResStringRec ResStringRec, const System::TVarRec *Args, const System::NativeInt Args_High, int AHelpContext)/* overload */ : System::Sysutils::Exception(ResStringRec, Args, Args_High, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ inline __fastcall IKLayerException(System::NativeUInt Ident, const System::TVarRec *Args, const System::NativeInt Args_High, int AHelpContext)/* overload */ : System::Sysutils::Exception(Ident, Args, Args_High, AHelpContext) { }
	/* Exception.Destroy */ inline __fastcall virtual ~IKLayerException() { }
	
};

#pragma pack(pop)

#pragma pack(push,4)
class PASCALIMPLEMENTATION TIKLayers : public System::Classes::TPersistent
{
	typedef System::Classes::TPersistent inherited;
	
public:
	TIKLayer* operator[](int Index) { return this->Layers[Index]; }
	
private:
	TIKLayer* FOwner;
	System::Classes::TList* FLayers;
	TIKLayer* __fastcall GetLayer(int Index);
	int __fastcall GetCount();
	
protected:
	void __fastcall Add(TIKLayer* const ALayer);
	void __fastcall Remove(TIKLayer* const ALayer);
	void __fastcall Clear();
	
public:
	__fastcall virtual TIKLayers(TIKLayer* const AOwner);
	__fastcall virtual ~TIKLayers();
	bool __fastcall Contains(TIKLayer* const ALayer);
	__property int Count = {read=GetCount, nodefault};
	__property TIKLayer* Layers[int Index] = {read=GetLayer/*, default*/};
};

#pragma pack(pop)

typedef void __fastcall (__closure *TDrawLayerEvent)(Winapi::Gdipobj::TGPGraphics* const Graphics, const Iktypes::TIKRect &Rect);

enum DECLSPEC_DENUM TIKContentMode : unsigned int { cmStretch, cmAspectFit, cmAspectFill, cmCenter, cmTop, cmBottom, cmLeft, cmRight, cmTopLeft, cmTopRight, cmBottomLeft, cmBottomRight };

class PASCALIMPLEMENTATION TIKLayer : public Iktypes::TIKPersistent
{
	typedef Iktypes::TIKPersistent inherited;
	
private:
	Iktypes::TIKPoint FPosition;
	Ikimage::TIKImage* FContent;
	TIKLayers* FLayers;
	TIKLayer* FParent;
	System::Classes::TNotifyEvent FOnUpdate;
	float FOpacity;
	Iktypes::TIKSize FSize;
	float FTagFloat;
	TDrawLayerEvent FOnDrawLayer;
	bool FNeedRedraw;
	Ikanimation::TIKAnimationDictionary* FAnimations;
	Iktypes::TIKMatrix3D FTransform;
	Iktypes::TIKMatrix3D FLayersTransform;
	Iktypes::TIKPoint FAnchorPoint;
	int FTagInt;
	System::TObject* FTagObject;
	bool FVisible;
	Ikimage::TIKFilter* FShadow;
	Ikimage::TIKImage* FOutputImage;
	Iktypes::TIKRect FOutputExtent;
	Iktypes::TIKColorF FBackgroundColor;
	bool FNeedBackgroundUpdate;
	Ikimage::TIKImage* FOutputContent;
	Ikimage::TIKImage* FDrawContent;
	Iktypes::TIKRect FDrawContentExtent;
	Ikimage::TIKFilter* FComposeFilter;
	bool FNeedUpdateShadow;
	bool FShowShadow;
	Ikimage::TIKImage* FShadowImage;
	float FShadowRadius;
	Iktypes::TIKColorF FShadowColor;
	Iktypes::TIKPoint FShadowOffset;
	float FRotationAngle;
	TIKContentMode FContentMode;
	Ikimage::TIKImage* FOriginalImage;
	Ikimage::TIKFilter* FContentFilter;
	System::UnicodeString FName;
	float FXRotationAngle;
	float FYRotationAngle;
	void __fastcall SetPosition(const Iktypes::TIKPoint &Value);
	void __fastcall SetContent(Ikimage::TIKImage* const Value);
	void __fastcall SetParent(TIKLayer* const Value);
	void __fastcall SetOpacity(const float Value);
	void __fastcall SetSize(const Iktypes::TIKSize &Value);
	void __fastcall SetTransform(const Iktypes::TIKMatrix3D &Value);
	void __fastcall SetLayersTransform(const Iktypes::TIKMatrix3D &Value);
	void __fastcall SetAnchorPoint(const Iktypes::TIKPoint &Value);
	Iktypes::TIKMatrix3D __fastcall GetAbsoluteTransform();
	void __fastcall SetVisible(const bool Value);
	void __fastcall SetBackgroundColor(const Iktypes::TIKColorF &Value);
	void __fastcall SetShowShadow(const bool Value);
	void __fastcall SetShadowColor(const Iktypes::TIKColorF &Value);
	void __fastcall SetShadowOffset(const Iktypes::TIKPoint &Value);
	void __fastcall SetShadowRadius(const float Value);
	void __fastcall SetRotationAngle(const float Value);
	void __fastcall SetContentMode(const TIKContentMode Value);
	Iktypes::TIKRect __fastcall GetBounds();
	void __fastcall SetOnDrawLayer(const TDrawLayerEvent Value);
	void __fastcall SetContentFilter(Ikimage::TIKFilter* const Value);
	void __fastcall SetXRotationAngle(const float Value);
	void __fastcall SetYRotationAngle(const float Value);
	Iktypes::TIKMatrix3D __fastcall GetRotationTransform();
	
protected:
	void __fastcall UpdateBackground();
	void __fastcall UpdateDrawContent();
	void __fastcall UpdateShadow();
	void __fastcall NeedBackgroundUpdate();
	void __fastcall NeedUpdateShadow();
	virtual Ikimage::TIKImage* __fastcall GetOutputImage();
	virtual Iktypes::TIKRect __fastcall GetOutputExtent();
	virtual void __fastcall DoUpdate();
	bool __fastcall IsAnimationDisabled();
	virtual bool __fastcall DoDrawLayer();
	
public:
	__fastcall virtual TIKLayer();
	__fastcall virtual ~TIKLayer();
	Ikanimation::TIKAnimation* __fastcall AnimationForProperty(const System::UnicodeString APropertyName);
	void __fastcall AddAnimationForProperty(const System::UnicodeString APropertyName, Ikanimation::TIKAnimation* const Animation);
	void __fastcall RemoveAnimationForProperty(const System::UnicodeString APropertyName, Ikanimation::TIKAnimation* const Animation);
	void __fastcall RemoveAllAnimations();
	void __fastcall Add(TIKLayer* const ALayer);
	void __fastcall Remove(TIKLayer* const ALayer);
	void __fastcall RemoveFromParent();
	void __fastcall BeginUpdate();
	void __fastcall EndUpdate();
	bool __fastcall ContainsPoint(const Iktypes::TIKPoint &Point);
	TIKLayer* __fastcall HitTest(const Iktypes::TIKPoint &Point);
	void __fastcall Update();
	void __fastcall Redraw();
	__property Iktypes::TIKPoint AnchorPoint = {read=FAnchorPoint, write=SetAnchorPoint};
	__property Iktypes::TIKMatrix3D AbsoluteTransform = {read=GetAbsoluteTransform};
	__property Iktypes::TIKColorF BackgroundColor = {read=FBackgroundColor, write=SetBackgroundColor};
	__property TIKContentMode ContentMode = {read=FContentMode, write=SetContentMode, nodefault};
	__property Ikimage::TIKFilter* ContentFilter = {read=FContentFilter, write=SetContentFilter};
	__property Iktypes::TIKRect DrawContentExtent = {read=FDrawContentExtent};
	__property Iktypes::TIKPoint Position = {read=FPosition, write=SetPosition};
	__property Iktypes::TIKSize Size = {read=FSize, write=SetSize};
	__property Iktypes::TIKRect Bounds = {read=GetBounds};
	__property System::UnicodeString Name = {read=FName, write=FName};
	__property Ikimage::TIKImage* Content = {read=FContent, write=SetContent};
	__property Iktypes::TIKMatrix3D Transform = {read=FTransform, write=SetTransform};
	__property Ikimage::TIKImage* OutputImage = {read=GetOutputImage};
	__property Iktypes::TIKRect OutputExtent = {read=GetOutputExtent};
	__property TIKLayers* Layers = {read=FLayers};
	__property Iktypes::TIKMatrix3D LayersTransform = {read=FLayersTransform, write=SetLayersTransform};
	__property TIKLayer* Parent = {read=FParent, write=SetParent};
	__property Iktypes::TIKColorF ShadowColor = {read=FShadowColor, write=SetShadowColor};
	__property float ShadowRadius = {read=FShadowRadius, write=SetShadowRadius};
	__property Iktypes::TIKPoint ShadowOffset = {read=FShadowOffset, write=SetShadowOffset};
	__property System::TObject* TagObject = {read=FTagObject, write=FTagObject};
	__property float TagFloat = {read=FTagFloat, write=FTagFloat};
	__property int TagInt = {read=FTagInt, write=FTagInt, nodefault};
	__property System::Classes::TNotifyEvent OnUpdate = {read=FOnUpdate, write=FOnUpdate};
	__property TDrawLayerEvent OnDrawLayer = {read=FOnDrawLayer, write=SetOnDrawLayer};
	__property bool NeedRedraw = {read=FNeedRedraw, write=FNeedRedraw, nodefault};
	
__published:
	__property float RotationAngle = {read=FRotationAngle, write=SetRotationAngle};
	__property float XRotationAngle = {read=FXRotationAngle, write=SetXRotationAngle};
	__property float YRotationAngle = {read=FYRotationAngle, write=SetYRotationAngle};
	__property float Opacity = {read=FOpacity, write=SetOpacity};
	__property bool ShowShadow = {read=FShowShadow, write=SetShowShadow, nodefault};
	__property bool Visible = {read=FVisible, write=SetVisible, nodefault};
};


class PASCALIMPLEMENTATION TIKOvalLayer : public TIKLayer
{
	typedef TIKLayer inherited;
	
private:
	Winapi::Gdipobj::TGPBrush* FBrush;
	Winapi::Gdipobj::TGPPen* FPen;
	void __fastcall SetBrush(Winapi::Gdipobj::TGPBrush* const Value);
	void __fastcall SetPen(Winapi::Gdipobj::TGPPen* const Value);
	
protected:
	virtual void __fastcall DrawLayer(Winapi::Gdipobj::TGPGraphics* const Graphics, const Iktypes::TIKRect &Rect);
	
public:
	__fastcall virtual TIKOvalLayer();
	__fastcall virtual ~TIKOvalLayer();
	__property Winapi::Gdipobj::TGPBrush* Brush = {read=FBrush, write=SetBrush};
	__property Winapi::Gdipobj::TGPPen* Pen = {read=FPen, write=SetPen};
};


//-- var, const, procedure ---------------------------------------------------
}	/* namespace Iklayer */
#if !defined(DELPHIHEADER_NO_IMPLICIT_NAMESPACE_USE) && !defined(NO_USING_NAMESPACE_IKLAYER)
using namespace Iklayer;
#endif
#pragma pack(pop)
#pragma option pop

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// IklayerHPP
